//+---------------------------------------------------------------------+
//|                                                       J2JMASign.mq5 | 
//|                                  Copyright  2010, Nikolay Kositsin | 
//|                                 Khabarovsk,   farria@mail.redcom.ru | 
//+---------------------------------------------------------------------+ 
//|          SmoothAlgorithms.mqh |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2010, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
//----   
#property version   "1.02"
//----     
#property indicator_chart_window 
//----        
#property indicator_buffers 2
//----     
#property indicator_plots   2
//+------------------------------------------------+ 
//|          |
//+------------------------------------------------+ 
//---   1   
#property indicator_type1   DRAW_ARROW
//---         
#property indicator_color1  clrMagenta
//---    1  4
#property indicator_width1  4
//---    
#property indicator_label1  "J2JMA Sell"
//+------------------------------------------------+ 
//|             |
//+------------------------------------------------+ 
//---   2   
#property indicator_type2   DRAW_ARROW
//---         
#property indicator_color2  clrBlue
//---    2  4
#property indicator_width2  4
//---    
#property indicator_label2 "J2JMA Buy"
//+------------------------------------------------+ 
//|                              |
//+------------------------------------------------+ 
#define RESET 0 //        
//+------------------------------------------------+ 
//|                          |
//+------------------------------------------------+ 
enum Applied_price_ // 
  {
   PRICE_CLOSE_ = 1,     //Close
   PRICE_OPEN_,          //Open
   PRICE_HIGH_,          //High
   PRICE_LOW_,           //Low
   PRICE_MEDIAN_,        //Median Price (HL/2)
   PRICE_TYPICAL_,       //Typical Price (HLC/3)
   PRICE_WEIGHTED_,      //Weighted Close (HLCC/4)
   PRICE_SIMPL_,         //Simpl Price (OC/2)
   PRICE_QUARTER_,       //Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  //TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_,  //TrendFollow_2 Price 
   PRICE_DEMARK_         //Demark Price
  };
//+------------------------------------------------+ 
//|                      |
//+------------------------------------------------+ 
input double Length1 = 5; //    
input double Length2 = 5; //    
input double Phase1= 100; //   
//----    -100 ... +100,
//----     ;
input double Phase2=100;  //   
//----    -100 ... +100,
//----     ;
input Applied_price_ IPC=PRICE_CLOSE_; //  
//+------------------------------------------------+ 
//----   ,    
//----      
double BuyBuffer[];
double SellBuffer[];
//----      
int ATR_Handle;
//----      
int min_rates_,min_rates_total;
//+------------------------------------------------------------------+
//|   CJJMA                                            |
//+------------------------------------------------------------------+
#include <SmoothAlgorithms.mqh> 
//+------------------------------------------------------------------+   
//| J2JMA indicator initialization function                          | 
//+------------------------------------------------------------------+ 
int OnInit()
  {
//----     
   min_rates_=30;
   min_rates_total=min_rates_+31+3;
//----     
   int ATR_Period=15;
   min_rates_total=int(MathMax(ATR_Period,min_rates_total));
//----    ATR
   ATR_Handle=iATR(NULL,0,ATR_Period);
   if(ATR_Handle==INVALID_HANDLE)
     {
      Print("      ATR");
      return(INIT_FAILED);
     }
//----      
   SetIndexBuffer(0,SellBuffer,INDICATOR_DATA);
//----       1
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   
   PlotIndexSetInteger(0,PLOT_ARROW,159);
//----      
   SetIndexBuffer(1,BuyBuffer,INDICATOR_DATA);
//----       2
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//----   
   PlotIndexSetInteger(1,PLOT_ARROW,159);
//----      
   string shortname;
   StringConcatenate(shortname,"J2JMA( Length1 = ",Length1,", Length2 = ",Length2,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----    CJJMA   JJMASeries_Cls.mqh
   CJJMA JMA;
//----       
   JMA.JJMALengthCheck("Length1", (int)Length1);
   JMA.JJMALengthCheck("Length2", (int)Length2);
//----       
   JMA.JJMAPhaseCheck("Phase1", (int)Phase1);
   JMA.JJMAPhaseCheck("Phase2", (int)Phase2);
//---  
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+ 
//| J2JMA iteration function                                         | 
//+------------------------------------------------------------------+ 
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(BarsCalculated(ATR_Handle)<rates_total || rates_total<min_rates_total) return(RESET);
//----       
   double price,j1jma,j2jma,ATR[1];
   static double j2jma1,j2jma2;
//----        
   int first,bar;
//----    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
      first=0; //      
   else first=prev_calculated-1; //      
//----    CJJMA   JJMASeries_Cls.mqh
   static CJJMA JMA1,JMA2;
//----    
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      //----   PriceSeries     price_
      price=PriceSeries(IPC,bar,open,low,high,close);
      //----    JJMASeries
      //----  Phase  Length      (Din = 0)
      //----     begin   30, ..   JMA 
      j1jma=JMA1.JJMASeries(0,prev_calculated,rates_total,0,Phase1,Length1,price,bar,false);
      j2jma=JMA2.JJMASeries(min_rates_,prev_calculated,rates_total,0,Phase2,Length2,j1jma,bar,false);
      //----
      BuyBuffer[bar]=0.0;
      SellBuffer[bar]=0.0;
      //----
      if(j2jma2>=j2jma1 && j2jma1<j2jma)
        {
         if(CopyBuffer(ATR_Handle,0,time[bar],1,ATR)<=0) return(RESET);
         BuyBuffer[bar]=low[bar]-ATR[0]*3/8;
        }
      //----
      if(j2jma2<=j2jma1 && j2jma1>j2jma)
        {
         if(CopyBuffer(ATR_Handle,0,time[bar],1,ATR)<=0) return(RESET);
         SellBuffer[bar]=high[bar]+ATR[0]*3/8;
        }
      //----
      if(bar<rates_total-1)
        {
         j2jma2=j2jma1;
         j2jma1=j2jma;
        }
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
